#!/usr/bin/env bash
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*    This file is part of the test engine for the 11th DIMACS challenge     *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

OUTFILE=$1

# construct paths
SCRIPTPATH=`pwd`
TSTPATH=$SCRIPTPATH/testsets
BENCHPATH=$SCRIPTPATH/bench
SOLUTIONPATH=$SCRIPTPATH/results/solutions

NAME=`basename $OUTFILE .out`
DIR=`dirname $OUTFILE`
OUTFILE=$DIR/$NAME.out
RESFILE=$DIR/$NAME.res
TMPFILE=$DIR/$NAME.tmp

TSTNAME=`echo $NAME | sed 's/\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).*/\1/g'`
SOLVER=`echo $NAME | sed 's/\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).*/\2/g'`
THREADS=`echo $NAME | sed 's/\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).*/\3/g'`
TIME=`echo $NAME | sed 's/\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).\([a-zA-Z0-9_-]*\).*/\4/g'`

echo > $TMPFILE

# loop over all instance names which are listed in the test set file name
for i in `cat $TSTPATH/$TSTNAME.test`
do
    FILENAME=`basename $i .gz`
    FILENAME=`basename $FILENAME .stp`

    echo @01 $FILENAME =========== >> $TMPFILE
    echo @02 $TIME >> $TMPFILE

    SOLFILE=$SOLUTIONPATH/$TSTNAME.$FILENAME.$SOLVER.$THREADS.$TIME.sol

    cat $SOLFILE >> $TMPFILE

    echo =ready= >> $TMPFILE
done

awk -f scripts/parse.awk $BENCHPATH/score.log $TSTPATH/$TSTNAME.solu $TMPFILE | tee $RESFILE
